-- Deploy tipus:email to pg
-- requires: schema_tipus
-- requires: extension_citext

begin;

set search_path to tipus, public;

-- regular expression from https://html.spec.whatwg.org/multipage/input.html#valid-e-mail-address
create domain email as citext
    check ( value ~
            '^[a-zA-Z0-9.!#$%&''*+/=?^_`{|}~-]+@[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)*$' );

comment on domain email is 'A valid email address according to HTML5 spec.';

commit;
