-- Test build_cookie
set client_min_messages to warning;
create extension if not exists pgtap;
reset client_min_messages;

begin;

select plan(13);

set search_path to tipus, auth, public;

select has_function('tipus', 'build_cookie', array ['email', 'text']);
select function_lang_is('tipus', 'build_cookie', array ['email', 'text'], 'sql');
select function_returns('tipus', 'build_cookie', array ['email', 'text'], 'text');
select isnt_definer('tipus', 'build_cookie', array ['email', 'text']);
select volatility_is('tipus', 'build_cookie', array ['email', 'text'], 'stable');
select function_privs_are('tipus', 'build_cookie', array ['email', 'text'], 'guest', array []::text[]);
select function_privs_are('tipus', 'build_cookie', array ['email', 'text'], 'publisher', array ['EXECUTE']);
select function_privs_are('tipus', 'build_cookie', array ['email', 'text'], 'admin', array ['EXECUTE']);
select function_privs_are('tipus', 'build_cookie', array ['email', 'text'], 'authenticator', array []::text[]);

set client_min_messages to warning;
truncate auth."user" cascade;
reset client_min_messages;

insert into auth."user" (user_id, email, name, password, role, cookie, cookie_expires_at)
values (1, 'demo@tandem.blog', 'Demo', 'test', 'publisher', '44facbb30d8a419dfd4bfbc44a4b5539d4970148dfc84bed0e',
        current_timestamp + interval '1 month')
     , (9, 'admin@tandem.blog', 'Demo', 'test', 'admin', '12af4c88b528c2ad4222e3740496ecbc58e76e26f087657524',
        current_timestamp + interval '1 month')
;

select is(
               build_cookie('test@example.com'::email, '123abc'),
               '123abc/test@example.com',
               'Should build the cookie with the given user and cookie value'
           );

select set_cookie('44facbb30d8a419dfd4bfbc44a4b5539d4970148dfc84bed0e/demo@tandem.blog');
reset role;

select is(
               build_cookie(),
               '44facbb30d8a419dfd4bfbc44a4b5539d4970148dfc84bed0e/demo@tandem.blog',
               'Should build the cookie for the logged in user'
           );


select set_cookie('12af4c88b528c2ad4222e3740496ecbc58e76e26f087657524/admin@tandem.blog');
reset role;

select is(
               build_cookie(),
               '12af4c88b528c2ad4222e3740496ecbc58e76e26f087657524/admin@tandem.blog',
               'Should build the cookie for the other logged in user'
           );


select set_cookie('ashtasth');
reset role;

select is(
               build_cookie(),
               '/',
               'Should build the cookie for the guest user'
           );


select *
from finish();

rollback;
