-- Test current_user_email
set client_min_messages to warning;
create extension if not exists pgtap;
reset client_min_messages;

begin;

set search_path to tipus, auth, public;

select plan(15);

select has_function('tipus', 'current_user_email', array []::name[]);
select function_lang_is('tipus', 'current_user_email', array []::name[], 'sql');
select function_returns('tipus', 'current_user_email', array []::name[], 'text');
select isnt_definer('tipus', 'current_user_email', array []::name[]);
select volatility_is('tipus', 'current_user_email', array []::name[], 'stable');
select function_privs_are('tipus', 'current_user_email', array []::name[], 'guest', array ['EXECUTE']);
select function_privs_are('tipus', 'current_user_email', array []::name[], 'publisher', array ['EXECUTE']);
select function_privs_are('tipus', 'current_user_email', array []::name[], 'admin', array ['EXECUTE']);
select function_privs_are('tipus', 'current_user_email', array []::name[], 'authenticator', array []::text[]);

set client_min_messages to warning;
truncate auth."user" cascade;
reset client_min_messages;

insert into auth."user" (user_id, email, name, password, role, cookie, cookie_expires_at)
values (1, 'demo@tandem.blog', 'Demo', 'test', 'publisher', '44facbb30d8a419dfd4bfbc44a4b5539d4970148dfc84bed0e',
        current_timestamp + interval '1 month')
     , (5, 'admin@tandem.blog', 'Demo', 'test', 'admin', '12af4c88b528c2ad4222e3740496ecbc58e76e26f087657524',
        current_timestamp + interval '1 month')
;

select lives_ok(
               $$ select set_cookie('44facbb30d8a419dfd4bfbc44a4b5539d4970148dfc84bed0e/demo@tandem.blog') $$,
               'Should change ok for the first user'
           );

select is(current_user_email(), 'demo@tandem.blog', 'Should return the email of the first user');

reset role;


select lives_ok(
               $$ select set_cookie('12af4c88b528c2ad4222e3740496ecbc58e76e26f087657524/admin@tandem.blog') $$,
               'Should change ok for the second user'
           );

select is(current_user_email(), 'admin@tandem.blog', 'Should return the email of the second user');

reset role;

select lives_ok(
               $$ select set_cookie('') $$,
               'Should change ok for a guest user'
           );

select is(current_user_email(), '', 'Should return an empty string');

reset role;


select *
from finish();

rollback;
